## gr-limesdr 3.0.1.10.69

=== CMakeLists.txt ===
# Copyright 2011-2020 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-limesdr
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Project setup
########################################################################
cmake_minimum_required(VERSION 3.8)
project(gr-limesdr CXX C)
enable_testing()

# Install to PyBOMBS target prefix if defined
if(DEFINED ENV{PYBOMBS_PREFIX})
    set(CMAKE_INSTALL_PREFIX $ENV{PYBOMBS_PREFIX})
    message(STATUS "PyBOMBS installed GNU Radio. Setting CMAKE_INSTALL_PREFIX to $ENV{PYBOMBS_PREFIX}")
endif()

# Select the release build type by default to get optimization flags
if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
   message(STATUS "Build type not specified: defaulting to release.")
endif(NOT CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "")

# Make sure our local CMake Modules path comes first
list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_SOURCE_DIR}/cmake/Modules)

# Set the version information here
set(VERSION_MAJOR 1)
set(VERSION_API   0)
set(VERSION_ABI   0)
set(VERSION_PATCH git)

cmake_policy(SET CMP0011 NEW)

# Enable generation of compile_commands.json for code completion engines
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

########################################################################
# Compiler specific setup
########################################################################
if((CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
    CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    AND NOT WIN32)
    #http://gcc.gnu.org/wiki/Visibility
    add_definitions(-fvisibility=hidden)
endif()

IF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    SET(CMAKE_CXX_STANDARD 14)
ELSEIF(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    SET(CMAKE_CXX_STANDARD 14)
ELSEIF(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    SET(CMAKE_CXX_STANDARD 14)
ELSE()
    message(WARNING "C++ standard could not be set because compiler is not GNU, Clang or MSVC.")
ENDIF()

IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    SET(CMAKE_C_STANDARD 11)
ELSEIF(CMAKE_C_COMPILER_ID MATCHES "Clang")
    SET(CMAKE_C_STANDARD 11)
ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
    SET(CMAKE_C_STANDARD 11)
ELSE()
    message(WARNING "C standard could not be set because compiler is not GNU, Clang or MSVC.")
ENDIF()

########################################################################
# Install directories
########################################################################
include(FindPkgConfig)
find_package(Gnuradio "3.9" REQUIRED)
include(GrVersion)

include(GrPlatform) #define LIB_SUFFIX

if(NOT CMAKE_MODULES_DIR)
  set(CMAKE_MODULES_DIR lib${LIB_SUFFIX}/cmake)
endif(NOT CMAKE_MODULES_DIR)

set(GR_INCLUDE_DIR      include/limesdr)
set(GR_CMAKE_DIR        ${CMAKE_MODULES_DIR}/limesdr)
set(GR_PKG_DATA_DIR     ${GR_DATA_DIR}/${CMAKE_PROJECT_NAME})
set(GR_PKG_DOC_DIR      ${GR_DOC_DIR}/${CMAKE_PROJECT_NAME})
set(GR_PKG_CONF_DIR     ${GR_CONF_DIR}/${CMAKE_PROJECT_NAME}/conf.d)
set(GR_PKG_LIBEXEC_DIR  ${GR_LIBEXEC_DIR}/${CMAKE_PROJECT_NAME})

########################################################################
# On Apple only, set install name and use rpath correctly, if not already set
########################################################################
if(APPLE)
    if(NOT CMAKE_INSTALL_NAME_DIR)
        set(CMAKE_INSTALL_NAME_DIR
            ${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR} CACHE
            PATH "Library Install Name Destination Directory" FORCE)
    endif(NOT CMAKE_INSTALL_NAME_DIR)
    if(NOT CMAKE_INSTALL_RPATH)
        set(CMAKE_INSTALL_RPATH
            ${CMAKE_INSTALL_PREFIX}/${GR_LIBRARY_DIR} CACHE
            PATH "Library Install RPath" FORCE)
    endif(NOT CMAKE_INSTALL_RPATH)
    if(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
        set(CMAKE_BUILD_WITH_INSTALL_RPATH ON CACHE
            BOOL "Do Build Using Library Install RPath" FORCE)
    endif(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
endif(APPLE)

########################################################################
# Find gnuradio build dependencies
########################################################################
find_package(Doxygen)

########################################################################
# PyBind11 Related
########################################################################

find_package(pybind11 REQUIRED)
execute_process(
    COMMAND "${PYTHON_EXECUTABLE}" -c
    "try:\n import numpy\n import os\n inc_path = numpy.get_include()\n if os.path.exists(os.path.join(inc_path, 'numpy', 'arrayobject.h')):\n  print(inc_path, end='')\nexcept:\n pass"
    OUTPUT_VARIABLE PYTHON_NUMPY_INCLUDE_DIR)
# format path in CMake-style for consistency with other path variables
# (a consistent style helps conda builds by using the same path separators)
file(TO_CMAKE_PATH "${PYTHON_NUMPY_INCLUDE_DIR}" PYTHON_NUMPY_INCLUDE_DIR)

########################################################################
# Find LimeSuite
########################################################################
MESSAGE(STATUS "Configuring LimeSuite C++ Libraries...")
find_package(LimeSuite)

########################################################################
# LimeRFE
########################################################################
include(FeatureSummary)
include(CMakeDependentOption)
option(ENABLE_RFE "Enable LimeRFE support" OFF)
add_feature_info(LimeRFE ENABLE_LIBRARY "LimeRFE support")
if(ENABLE_RFE)
    message(STATUS "Enabling LimeRFE support")
endif()

########################################################################
# Setup doxygen option
########################################################################
if(DOXYGEN_FOUND)
    option(ENABLE_DOXYGEN "Build docs using Doxygen" ON)
else(DOXYGEN_FOUND)
    option(ENABLE_DOXYGEN "Build docs using Doxygen" OFF)
endif(DOXYGEN_FOUND)

########################################################################
# Create uninstall target
########################################################################
configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
@ONLY)

add_custom_target(uninstall
    ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
    )

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(include/limesdr)
add_subdirectory(lib)
add_subdirectory(apps)
add_subdirectory(docs)
# NOTE: manually update below to use GRC to generate C++ flowgraphs w/o python
if(ENABLE_PYTHON)
  message(STATUS "PYTHON and GRC components are enabled")
  add_subdirectory(python)
  add_subdirectory(grc)
else(ENABLE_PYTHON)
  message(STATUS "PYTHON and GRC components are disabled")
endif(ENABLE_PYTHON)

=== apps/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-limesdr
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

include(GrPython)

GR_PYTHON_INSTALL(
    PROGRAMS
    DESTINATION bin
)

=== docs/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-limesdr
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup dependencies
########################################################################
find_package(Doxygen)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_DOXYGEN)

########################################################################
# Add subdirectories
########################################################################
add_subdirectory(doxygen)

endif(ENABLE_DOXYGEN)

=== grc/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# This software is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# This software is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

install(FILES
    limesdr_source.block.yml
    limesdr_sink.block.yml
    DESTINATION share/gnuradio/grc/blocks
)
if(ENABLE_RFE)
    install(FILES limesdr_rfe.block.yml DESTINATION share/gnuradio/grc/blocks)
endif()

=== lib/CMakeLists.txt ===
# Copyright 2011,2012,2016,2018,2019 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-limesdr
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup library
########################################################################
include(GrPlatform) #define LIB_SUFFIX

list(APPEND limesdr_sources
    device_handler.cc
    logging.cc
    source_impl.cc
    sink_impl.cc
    device_handler.cc
)

if(ENABLE_RFE)
    list(APPEND limesdr_sources
    rfe_impl.cc
    )
endif()

set(limesdr_sources "${limesdr_sources}" PARENT_SCOPE)
if(NOT limesdr_sources)
    MESSAGE(STATUS "No C++ sources... skipping lib/")
    return()
endif(NOT limesdr_sources)

add_library(gnuradio-limesdr SHARED ${limesdr_sources})
target_link_libraries(gnuradio-limesdr PUBLIC gnuradio::gnuradio-runtime LimeSuite)
target_include_directories(gnuradio-limesdr
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
    PUBLIC $<INSTALL_INTERFACE:include>
  )
set_target_properties(gnuradio-limesdr PROPERTIES DEFINE_SYMBOL "gnuradio_limesdr_EXPORTS")

if(APPLE)
    set_target_properties(gnuradio-limesdr PROPERTIES
        INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib"
    )
endif(APPLE)

add_definitions( -DGR_LIMESDR_VER="${VERSION}" )

########################################################################
# Install built library files
########################################################################
include(GrMiscUtils)
GR_LIBRARY_FOO(gnuradio-limesdr)

########################################################################
# Print summary
########################################################################
message(STATUS "Using install prefix: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Building for version: ${VERSION} / ${LIBVER}")

########################################################################
# Build and register unit test
########################################################################
include(GrTest)

# If your unit tests require special include paths, add them here
#include_directories()
# List all files that contain Boost.UTF unit tests here
list(APPEND test_limesdr_sources
)
# Anything we need to link to for the unit tests go here
list(APPEND GR_TEST_TARGET_DEPS gnuradio-limesdr)

if(NOT test_limesdr_sources)
    MESSAGE(STATUS "No C++ unit tests... skipping")
    return()
endif(NOT test_limesdr_sources)

foreach(qa_file ${test_limesdr_sources})
    GR_ADD_CPP_TEST("limesdr_${qa_file}"
        ${CMAKE_CURRENT_SOURCE_DIR}/${qa_file}
    )
endforeach(qa_file)

=== python/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-limesdr
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Include python install macros
########################################################################
include(GrPython)
if(NOT PYTHONINTERP_FOUND)
    return()
endif()

add_subdirectory(bindings)

########################################################################
# Install python sources
########################################################################
GR_PYTHON_INSTALL(
    FILES
    __init__.py
    DESTINATION ${GR_PYTHON_DIR}/limesdr
)

########################################################################
# Handle the unit tests
########################################################################
include(GrTest)

set(GR_TEST_TARGET_DEPS gnuradio-limesdr)

=== docs/doxygen/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-limesdr
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Create the doxygen configuration file
########################################################################
file(TO_NATIVE_PATH ${CMAKE_SOURCE_DIR} top_srcdir)
file(TO_NATIVE_PATH ${CMAKE_BINARY_DIR} top_builddir)
file(TO_NATIVE_PATH ${CMAKE_SOURCE_DIR} abs_top_srcdir)
file(TO_NATIVE_PATH ${CMAKE_BINARY_DIR} abs_top_builddir)

set(HAVE_DOT ${DOXYGEN_DOT_FOUND})
set(enable_html_docs YES)
set(enable_latex_docs NO)
set(enable_mathjax NO)
set(enable_xml_docs YES)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
@ONLY)

set(BUILT_DIRS ${CMAKE_CURRENT_BINARY_DIR}/xml ${CMAKE_CURRENT_BINARY_DIR}/html)

########################################################################
# Make and install doxygen docs
########################################################################
add_custom_command(
    OUTPUT ${BUILT_DIRS}
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating documentation with doxygen"
)

add_custom_target(doxygen_target ALL DEPENDS ${BUILT_DIRS})

install(DIRECTORY ${BUILT_DIRS} DESTINATION ${GR_PKG_DOC_DIR})

=== include/limesdr/CMakeLists.txt ===
# Copyright 2011,2012 Free Software Foundation, Inc.
#
# This file was generated by gr_modtool, a tool from the GNU Radio framework
# This file is a part of gr-limesdr
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Install public header files
########################################################################
install(FILES
    api.h
    sink.h
    source.h
    DESTINATION include/limesdr
)
if(ENABLE_RFE)
    install(FILES rfe.h DESTINATION include/limesdr
    )
endif()

=== python/bindings/CMakeLists.txt ===
# Copyright 2020 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Check if there is C++ code at all
########################################################################
if(NOT limesdr_sources)
    MESSAGE(STATUS "No C++ sources... skipping python bindings")
    return()
endif(NOT limesdr_sources)

########################################################################
# Check for pygccxml
########################################################################
GR_PYTHON_CHECK_MODULE_RAW(
    "pygccxml"
    "import pygccxml"
    PYGCCXML_FOUND
    )

include(GrPybind)

########################################################################
# Python Bindings
########################################################################

list(APPEND limesdr_python_files
    sink_python.cc
    source_python.cc
    python_bindings.cc)

if(ENABLE_RFE)
    list(APPEND limesdr_python_files rfe_python.cc)
    add_compile_definitions(ENABLE_RFE)
endif()

GR_PYBIND_MAKE_OOT(limesdr
   ../..
   gr::limesdr
   "${limesdr_python_files}")

install(TARGETS limesdr_python DESTINATION ${GR_PYTHON_DIR}/limesdr COMPONENT pythonapi)

=== debian/changelog ===
gr-limesdr (3.0.1.10.69-4) unstable; urgency=medium

  [ A. Maitland Bottoms ]
  * Update standards version to 4.7.2, no changes needed.
  * Depends change to pkgconf
  * Rebuild with pybind11 3.x (Closes: #1116300)

  [ Kentaro Hayashi ]
  * Use "GNU Radio" wording

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 17 Oct 2025 19:06:12 -0400

gr-limesdr (3.0.1.10.69-3) unstable; urgency=medium

  * upload to unstable
  * autopkgtest superficial tests passing again (Closes: #1043065)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 07 Aug 2023 21:52:51 -0400

gr-limesdr (3.0.1.10.69-2) experimental; urgency=medium

  * Bump SONAME due to ABI changes (Closes: 1043120)
  * Upload to experimental for new libgnuradio-limesdr3.0.2 package

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 06 Aug 2023 12:58:30 -0400

gr-limesdr (3.0.1.10.69-1) unstable; urgency=medium

  [ Christoph Berg ]
  * Update watch file to look at github tags.

  [ A. Maitland Bottoms ]
  * New upstream source from gr-3.10 branch: v3.0.1-69-gd0fac85
  * Update standards version to 4.6.2, no changes needed.
  * Adjust dependencies (now using pybind11 instead of swig)
  * add doc-base entries.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 05 Aug 2023 14:10:29 -0400

=== debian/control ===
Source: gr-limesdr
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: A. Maitland Bottoms <bottoms@debian.org>,
           Andreas Bombe <aeb@debian.org>,
           Christoph Berg <myon@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               doxygen,
               gnuradio-dev (>= 3.10),
               libgmp-dev,
               liblimesuite-dev (>= 19.04),
               libspdlog-dev,
               libvolk-dev,
               pkgconf,
	       pybind11-dev,
               python3-dev,
               python3-numpy
Standards-Version: 4.7.2
Homepage: https://wiki.myriadrf.org/Gr-limesdr_Plugin_for_GNURadio
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/gr-limesdr
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/gr-limesdr.git

Package: gr-limesdr
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: gnuradio,
         libgnuradio-limesdr3.0.2 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Description: LimeSDR blocks for GNU Radio
 LimeSDR is a low cost, open source software defined radio (SDR) platform that
 can be used to support just about any type of wireless communication standard.
 .
 Currently this plugin supports LimeSDR-USB and LimeSDR-Mini boards.
 .
 The gr-limesdr blocks for GNU Radio can be used to create flowgraphs that
 interface LimeSDR devices through liblimesuite.
 .
 This package contains the development files.

Package: libgnuradio-limesdr3.0.2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: LimeSDR blocks for GNU Radio (runtime library)
 LimeSDR is a low cost, open source software defined radio (SDR) platform that
 can be used to support just about any type of wireless communication standard.
 .
 Currently this plugin supports LimeSDR-USB and LimeSDR-Mini boards.
 .
 The gr-limesdr blocks for GNU Radio can be used to create flowgraphs that
 interface LimeSDR devices through liblimesuite.
 .
 This package contains the shared library.

=== debian/tests/control ===
Tests: python
Depends: gr-limesdr, python3-all
Restrictions: superficial

=== debian/watch ===
version=4
https://github.com/myriadrf/gr-limesdr/tags .*/v([\d\.]+)\.tar\.gz
